import { ApolloCache, Cache, Transaction } from 'apollo-cache';
import { DocumentNode } from 'graphql';
export interface LogOptions {
    logger?: (...args: any[]) => void;
    formatter?: (methodName: string, args: any[], error: any, result: any) => string;
}
export declare const defaultFormatter: (methodName: string, args: any[], error: any, result: any) => string;
export declare const defaultLogger: (...args: any[]) => void;
export default class LogCache<TCache> extends ApolloCache<TCache> {
    private cache;
    private options;
    constructor(cache: ApolloCache<TCache>, options?: LogOptions);
    read<T>(query: Cache.ReadOptions): T;
    write(write: Cache.WriteOptions): void;
    diff<T>(query: Cache.DiffOptions): Cache.DiffResult<T>;
    watch(watch: Cache.WatchOptions): () => void;
    evict(query: Cache.EvictOptions): Cache.EvictionResult;
    reset(): Promise<void>;
    restore(serializedState: TCache): ApolloCache<TCache>;
    extract(optimistic: boolean): TCache;
    removeOptimistic(id: string): void;
    performTransaction(transaction: Transaction<any>): void;
    recordOptimisticTransaction(transaction: Transaction<any>, id: string): void;
    transformDocument(document: DocumentNode): DocumentNode;
    private log<T>(methodName, args, operation);
}
