"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var apollo_cache_1 = require("apollo-cache");
var graphql_1 = require("graphql");
exports.defaultFormatter = function (methodName, args, error, result) {
    return ['transformDocument', 'watch'].indexOf(methodName) >= 0
        ? undefined
        : methodName +
            '(' +
            (args.length === 1 && !!args[0] && (!!args[0].definitions || (!!args[0].query && !!args[0].query.definitions))
                ? graphql_1.print(args[0].query || args[0])
                : JSON.stringify(args)) +
            ')' +
            (" " + (error ? 'e' : '') + "-> ") +
            (!error && result && result.definitions ? graphql_1.print(result) : JSON.stringify(error || result));
};
exports.defaultLogger = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return console.log.apply(null, args);
};
var getDefaultLogOptions = function (options) {
    var result = options;
    if (!result.formatter) {
        result.formatter = exports.defaultFormatter;
    }
    if (!result.logger) {
        result.logger = exports.defaultLogger;
    }
    return result;
};
var LogCache = (function (_super) {
    __extends(LogCache, _super);
    function LogCache(cache, options) {
        var _this = _super.call(this) || this;
        _this.cache = cache;
        _this.options = getDefaultLogOptions(options);
        return _this;
    }
    LogCache.prototype.read = function (query) {
        var _this = this;
        return this.log('read', [query], function () { return _this.cache.read(query); });
    };
    LogCache.prototype.write = function (write) {
        var _this = this;
        return this.log('write', [write], function () { return _this.cache.write(write); });
    };
    LogCache.prototype.diff = function (query) {
        var _this = this;
        return this.log('diff', [query], function () { return _this.cache.diff(query); });
    };
    LogCache.prototype.watch = function (watch) {
        var _this = this;
        return this.log('watch', [watch], function () { return _this.cache.watch(watch); });
    };
    LogCache.prototype.evict = function (query) {
        var _this = this;
        return this.log('evict', [query], function () { return _this.cache.evict(query); });
    };
    LogCache.prototype.reset = function () {
        return __awaiter(this, void 0, void 0, function () {
            var error, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this.cache.reset()];
                    case 1:
                        _a.sent();
                        return [3, 3];
                    case 2:
                        e_1 = _a.sent();
                        error = e_1;
                        return [3, 3];
                    case 3: return [2, this.log('reset', [], function () {
                            if (error) {
                                throw error;
                            }
                        })];
                }
            });
        });
    };
    LogCache.prototype.restore = function (serializedState) {
        var _this = this;
        return this.log('restore', [serializedState], function () { return _this.cache.restore(serializedState); });
    };
    LogCache.prototype.extract = function (optimistic) {
        var _this = this;
        return this.log('extract', [optimistic], function () { return _this.cache.extract(optimistic); });
    };
    LogCache.prototype.removeOptimistic = function (id) {
        var _this = this;
        this.log('removeOptimistic', [id], function () { return _this.cache.removeOptimistic(id); });
    };
    LogCache.prototype.performTransaction = function (transaction) {
        var _this = this;
        this.log('performTransaction', [transaction], function () { return _this.cache.performTransaction(transaction); });
    };
    LogCache.prototype.recordOptimisticTransaction = function (transaction, id) {
        var _this = this;
        this.log('recordOptimisticTransaction', [transaction, id], function () {
            return _this.cache.recordOptimisticTransaction(transaction, id);
        });
    };
    LogCache.prototype.transformDocument = function (document) {
        var _this = this;
        return this.log('transformDocument', [document], function () { return _this.cache.transformDocument(document); });
    };
    LogCache.prototype.log = function (methodName, args, operation) {
        var result;
        var error;
        try {
            result = operation();
            return result;
        }
        catch (e) {
            error = e;
            throw e;
        }
        finally {
            var msg = this.options.formatter(methodName, args, error, result);
            if (msg) {
                this.options.logger(msg);
            }
        }
    };
    return LogCache;
}(apollo_cache_1.ApolloCache));
exports.default = LogCache;
//# sourceMappingURL=index.js.map